RepHeaderRemember = LibStub("AceAddon-3.0"):NewAddon("RepHeaderRemember", "AceHook-3.0")

local defaults = {
	profile = {
		HeaderCollapsed = {}
	},
}

local db
local strOther = _G.FACTION_OTHER

-- Called when the addon is loaded
function RepHeaderRemember:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("RepHeaderRememberDB", defaults)
	db = self.db.profile.HeaderCollapsed
end

-- Called when the addon is enabled
function RepHeaderRemember:OnEnable()
	RepHeaderRemember:HookScript(ReputationFrame, "OnShow")
	RepHeaderRemember:HookScript(ReputationFrame, "OnHide")
end

-- Called when the addon is Disabled
function RepHeaderRemember:OnDisable()
	RepHeaderRemember:UnhookAll()
end

-- If Rep frame is being closed, collect header state
function RepHeaderRemember:OnHide(...)
	local numShown = GetNumFactions()

	-- first go through visible factions
	for index = 1, numShown do
		local name, _, _, _, _, _, _, _, isHeader, isCollapsed = GetFactionInfo(index)
		if isHeader then 
			db[name] = isCollapsed
		end
	end

	local index = 1 + numShown
	local name, _, _, _, _, _, _, _, isHeader, isCollapsed = GetFactionInfo(index)
	while name and name ~= strOther and index < 250 do
		if isHeader then 
			db[name] = isCollapsed
		end
		index = index + 1
		name, _, _, _, _, _, _, _, isHeader, isCollapsed = GetFactionInfo(index)
	end
end

-- If Rep frame is being shown, collapse headers
function RepHeaderRemember:OnShow(...)
	local numShown = GetNumFactions()

	-- first we're going to go through all the factions that are currently hidden
	-- looking for sub headers that are supposed to be collapsed but are not
	-- stop looking if name faction name is nil, FACTION_OTHER or i feels too big
	local index = 1 + numShown
	local name, _, _, _, _, _, _, _, isHeader, isCollapsed = GetFactionInfo(index)
	while name and name ~= strOther and index < 250 do
		if isHeader then
			local shouldCollapse = db[name]
			if shouldCollapse and not isCollapsed then
				CollapseFactionHeader(index)
				-- print("collapsing hidden header", index, name)
			elseif isCollapsed and not shouldCollapse then
				ExpandFactionHeader(index)
				-- print("expanding hidden header", index, name)
			end
		end
		index = index + 1
		name, _, _, _, _, _, _, _, isHeader, isCollapsed = GetFactionInfo(index)
	end
	-- print("last faction", index-1, GetFactionInfo(index-1))

	-- now go through the visible factions collapsing incorrect headers
	-- we'll start from the bottom and work up which should be safest approach
	for index = numShown, 1, -1 do
		 name, _, _, _, _, _, _, _, isHeader, isCollapsed = GetFactionInfo(index)
		if isHeader then
			local shouldCollapse = db[name]
			if shouldCollapse and not isCollapsed then
				CollapseFactionHeader(index)
				-- print("collapsing visible header", index, name)
			elseif isCollapsed and not shouldCollapse then
				ExpandFactionHeader(index)
				-- print("expanding visible header", index, name)
			end
		end
	end
end
